/* msp & Lippe 8/86.  Wait for events like "Clav # #>0" and 
/* "flutter #" and send messages associated with specific pitches */

#include <stdio.h>
#include "../max/sap/cplib.h"
extern long cptime;
#define NPITCH 128
#define NCHAR 128
#define SIZE (NPITCH*NCHAR)

struct pinst
{
	int p_run;			/* whether running */
	int p_debug;
	char p_clav[NPITCH][NCHAR];	/* what to send when you get a note */
	char p_flutter[NPITCH][NCHAR];	/* what to send when you get fluttery */
};

char *ciusage = "usage: cia [-w]";

 char *
cistart(ac,av)
 char **av;
{
	int i;
	struct pinst *pp= (struct pinst *)shmalloc(sizeof(struct pinst));
	pp->p_run = 1;
	pp->p_debug = 0;
	ac--; av++;
	while (ac && **av == '-')
	{
		if (!strcmp (av[0], "-d")) pp->p_debug = 1;
		else if (!strcmp (av[0], "-w")) pp->p_run = 0;
		else hate(ciusage);
		ac--;av++;
	}
	for (i=0; i<NPITCH; i++) pp->p_clav[i][0] = pp->p_flutter[i][0] = '\0';
	return ((char *)pp);
}

ciread(cpp)
 register char *cpp;
{
	register struct pinst *pp = (struct pinst *)cpp;
	register char *s = rstring(), *cp;
	if (!strcmp(s,"clav"))
	{
		int pitch, vel;
		register char *cp;
		if (!pp->p_run) return;
		if (erint(&pitch) || erint(&vel)) 
		{
			printf("clav WHAT?\n");
			return;
		}
		pitch &= 127;
		/* printf("%d %d\n", pitch, vel); */
		if (vel) 
		{
			if (pp->p_clav[pitch][0]) whiz(pp->p_clav[pitch]);
			else if (pitch >= 12 && pp->p_clav[pitch-12][0])
				whiz(pp->p_clav[pitch-12]);
			else if (pitch < 116 && pp->p_clav[pitch+12][0])
				whiz(pp->p_clav[pitch+12]);
		}
	}
	else if (!strcmp(s,"flutter"))
	{
		int pitch;
		register char *cp;
		if (!pp->p_run) return;
		if (erint(&pitch))
		{
			printf("flutter WHAT?\n");
			return;
		}
		pitch &= 127;
		if (pp->p_flutter[pitch][0]) whiz(pp->p_flutter[pitch]);
		else if (pitch >= 12 && pp->p_flutter[pitch-12][0])
			whiz(pp->p_flutter[pitch-12]);
		else if (pitch < 116 && pp->p_flutter[pitch+12][0])
			whiz(pp->p_flutter[pitch+12]);
	}
	else if (!strcmp(s,"start")) pp->p_run = 1;
	else if (!strcmp(s,"stop")) pp->p_run = 0;
	else if (!strcmp(s,"setflutter"))
	{
		int pitch;
		register char *cp, *endp;
		if (erint(&pitch)) 
		{
			printf("setflutter WHAT?\n");
			return;
		}
		pitch &= 127;	/* force pitch to a good range */
		cp = pp->p_flutter[pitch];
		endp = cp + NCHAR - 2;
		while (type() != L_NOMORE && cp < endp)
		{
			char *argp = rstring();
			while (*argp && cp < endp) *(cp++) = *(argp++);
			*(cp++) = '\0';
		}
		*cp = '\0';
	}
	else if (!strcmp(s,"rmflutter"))
	{
		int pitch;
		register char *cp;
		if (erint(&pitch)) 
		{
			printf("rmflutter WHAT?\n");
			return;
		}
		pitch &= 127;	/* force pitch to a good range */
		pp->p_flutter[pitch][0] = '\0';
	}
	else if (!strcmp(s,"setclav"))
	{
		int pitch;
		register char *cp, *endp;
		if (erint(&pitch)) 
		{
			printf("setclav WHAT?\n");
			return;
		}
		pitch &= 127;	/* force pitch to a good range */
		cp = pp->p_clav[pitch];
		endp = cp + NCHAR - 2;
		while (type() != L_NOMORE && cp < endp)
		{
			char *argp = rstring();
			while (*argp && cp < endp) *(cp++) = *(argp++);
			*(cp++) = '\0';
		}
		*cp = '\0';
	}
	else if (!strcmp(s,"rmclav"))
	{
		int pitch;
		register char *cp;
		if (erint(&pitch)) 
		{
			printf("rmclav WHAT?\n");
			return;
		}
		pitch &= 127;	/* force pitch to a good range */
		pp->p_clav[pitch][0] = '\0';
	}
	else
	{
		printf("cia: lost in Bolivia");
		dumpletter();
	}
}

whiz(cp)
 char *cp;
{
	while (*cp)
	{
		int whatcp, n = 0;
		if (*cp == ';') continue;
		if ((whatcp = ecpston(cp)) < 0)
		{
			printf("%s: no such CP\n", cp);
			while (*cp && *cp != ';') while (*(cp++));
		}
		else
		{
			while (*(cp++));	/* skip cp-to field */
			while (*cp && *cp != ';')
			{
				newletter(); n=0;
				while (*cp && *cp != ';' && *cp != ',')
				{
					if (*cp == '\\') cp++;
					wstring(cp);
					n++; 
					while (*(cp++));
				}
				if (n >= 0) send2(whatcp, cptime, cptime+50);
				if (*cp && *cp == ',') while (*(cp++));
			}
		}
		if (*cp) while (*(cp++));
	}
}

cistop(s)
 register char *s;
{
	free(s);
}
