/* sin.c */
/* p_coeff is model to do parallel amplitude control*/
/* control process to do Sinterpol */
#include "/u/4x/include/sys/file.h"
#include "/u/4x/include/la4x.h"
#include "/u/4x/include/MCB.h"
#include "/u/4x/max/cp/bag.h"
#include "Patch/x.h"
#include "/u/4x/max/sap/cplib.h"
#include <stdio.h>
#define NB_OSC_LECT 16
#define NOTE 4000	/* total memory in notes */
#define SEQ 20		/* max number of sequences */
int onsets[SEQ+1] = {0};
int plaques[SEQ];
int nseq = 0;		/* number of sequences read so far */
#define NORECORD 0
#define RECORDDEB 1
#define RECORDFIN 2
#define MAXURY 72
int zz_rate = 32000;
extern int cpno;	/* from MAX scheduler; number of this CP */
extern long cptime;	/* from scheduler; current time in milliseconds */
	short *p_duree;		/* time intervals between notes */
	short *p_longueur;	/* lengths of notes */
	int *p_coeff; 		/* table read speeds */
	short *p_amp; 		/* amplitudes */
	int p_kmax;			/* number of notes */
	short *p_dlist;	 	/* lists of the above things */
	short *p_llist;
	int *p_clist; 
	short *p_alist; 

/* things which need SEQ copies */
struct pinst 
{
	/* one-of-a-kind things */
	int p_seq;		/* sequence number */
	int p_osc_lect;
	int p_run;		/* flag indicating that "phrase" is running */
	int p_sync;		/* flag that a "phrase" letter is outstanding */
	int p_count;		/* number of calls to "phrase" */
	int p_durcnt;		/* number of temps-declenchement so far */
	int p_prevtime;		/* time of prev flute note input */
	int p_idcnt;		/* durations so far input by flute */
	int p_ury;		/* number of durations in rhythmic pattern */
	int p_pas;		/* number of steps */
	int p_recordwhat;	/* whether recording and if so what */
	int p_debfull;		/* have a debut sequence and want a fin one */
	int p_finfull;		/* have a fin sequence */
	int p_durdeb[MAXURY];	/* sequence of debut durations */
	int p_durfin[MAXURY];
	int p_which;		/* 0 or 1 */
} intinst[3];			/* space for two of these */
int pr2cp;

#define DEBUT 0x80000000
#define ONAMP 0x7fffffff
#define ONINCREMENT 0x800000
#define OFFINCREMENT (-0x80000)
#define OFFTIME 160	/* 125 msec turnoff time for envelope */
#define T1 4	/* minimum polling time */
#define T2 10	/* maximum polling time  */
#define T3 0	/* min and max times for starting "phrase" */
#define T4 30
char *malloc();

siread(x)
 char *x;
{
	register struct pinst *pp = (struct pinst *)x;
	register char *s = rstring();	/* the command */
	char filename[80];
	int shit, fd;
	if (!strcmp(s,"phrase"))
	{
		if (!pp->p_run) 
		{
			pp->p_sync = 0;
			return;
		}
		if (pp->p_count< p_kmax)	/* next time to wake up: */
		{
			long next,  time = p_longueur[pp->p_count], *phap;
			if (time < 200) time = 200;
			else if (time > 2000) time = 2000;
			next = cptime + time - OFFTIME;
		/* on choisit un oscillateur de lecture */
			pp->p_osc_lect = (pp->p_osc_lect + 1) % NB_OSC_LECT;
		/* on lance la lecture sur l'oscillateur */
			if (pp->p_which == 2)
			{
				R6_fre[pp->p_osc_lect]=p_coeff[pp->p_count];
				R6_a_inc[pp->p_osc_lect] = ONINCREMENT;
				R6_a_fin[pp->p_osc_lect] = 
					(p_amp[pp->p_count] << 16);
				phap = &R6_pha[pp->p_osc_lect];
				*phap = DEBUT; *phap = DEBUT;
			}
			else if (pp->p_which)
			{
				R4_fre[pp->p_osc_lect]=p_coeff[pp->p_count];
				R4_a_inc[pp->p_osc_lect] = ONINCREMENT;
				R4_a_fin[pp->p_osc_lect] = 
					(p_amp[pp->p_count] << 16);
				phap = &R4_pha[pp->p_osc_lect];
				*phap = DEBUT; *phap = DEBUT;
			}
			else
			{
				R3_fre[pp->p_osc_lect]=p_coeff[pp->p_count];
				R3_a_inc[pp->p_osc_lect] = ONINCREMENT;
				R3_a_fin[pp->p_osc_lect] = 
					(p_amp[pp->p_count] << 16);
				phap = &R3_pha[pp->p_osc_lect];
				*phap = DEBUT; *phap = DEBUT;
			}
		/* on se reveillera juste avant la catastrophe */
			newletter(); wstring("decay"); wint(pp->p_osc_lect);
				send2(cpno, next, next+T4);
			if (pp->p_count%10 == 0) printf("%d\n",pp->p_count);
		/* figure out time of next note */
			next = cptime + p_duree[pp->p_count];
			newletter(); wstring("phrase");
				send2(cpno, next, next+T4);
		}
		else 
		{
			pp->p_sync = 0;		/* no more letters scheduled */
			printf("fini...\n");
		}
		pp->p_count++;
	}
	else if (!strcmp(s,"decay"))	 /* on y est, silence ! */
	{
		int osc_lect = rint();
		if (pp->p_which == 2)
		{
			R6_a_inc[osc_lect] = OFFINCREMENT;
			R6_a_fin[osc_lect] = 0;
		}
		else if (pp->p_which)
		{
			R4_a_inc[osc_lect] = OFFINCREMENT;
			R4_a_fin[osc_lect] = 0;
		}
		else
		{
			R3_a_inc[osc_lect] = OFFINCREMENT;
			R3_a_fin[osc_lect] = 0;
		}
	}
	else if (!strcmp(s, "clav"))
	{
		int pit = rint(), vel = rint();
		if (!vel) return;
		if (pp->p_recordwhat == RECORDDEB)
		{
			if (pp->p_prevtime)
			{
				pp->p_durdeb[(pp->p_idcnt)++] =
					cptime - pp->p_prevtime;
				if (pp->p_idcnt >= pp->p_ury)
				{
					newletter(); wstring("gotdeb");
						send2(pr2cp, cptime, cptime+50);
					printf("got debut\n");
					pp->p_recordwhat = NORECORD;
					pp->p_debfull = 1;
				}
			}
		}
		else if (pp->p_recordwhat == RECORDFIN)
		{
			if (pp->p_prevtime)
			{
				pp->p_durfin[(pp->p_idcnt)++] = 
					cptime - pp->p_prevtime;
				if (pp->p_idcnt >= pp->p_ury)
				{
					newletter(); wstring("gotfin");
						send2(pr2cp, cptime, cptime+50);
					printf("gotfin\n");
					pp->p_recordwhat = NORECORD;
					pp->p_debfull = 0;
					pp->p_finfull = 1;
					addinter(pp, pp->p_durdeb,pp->p_durfin,
						pp->p_ury,pp->p_pas);
				}
			}
		}
		pp->p_prevtime = cptime;
	}
	else if (!strcmp(s, "sequence")) 
	{
		int i;
		if (erint(&i)) i = 0;
		boppo(pp, i);
	}
	else if (!strcmp(s, "recorddeb"))
	{
		if (erint(&pp->p_ury) || erint(&pp->p_pas) || pp->p_ury < 1 ||
			pp->p_pas < 1 || pp->p_ury > MAXURY) 
				BAG("recorddeb: bad values");
		pp->p_recordwhat = RECORDDEB;
		pp->p_prevtime = pp->p_idcnt = pp->p_debfull = pp->p_finfull = 
			0;
		newletter(); wstring("deb"); send2(pr2cp, cptime, cptime+50);
		printf("recorddeb....\n");
	}
	else if (!strcmp(s, "recordfin"))
	{
		if (!pp->p_debfull) BAG("recordfin: no debut yet");
		pp->p_recordwhat = RECORDFIN;
		pp->p_prevtime = pp->p_idcnt = 0;
		newletter(); wstring("fin"); send2(pr2cp, cptime, cptime+50);
		printf("recordfin....\n");
	}
	else if (!strcmp(s, "deb_fin"))
	{
		int i;
		if (erint(&pp->p_pas) || pp->p_pas < 1) 
			BAG("deb_fin: pas de 'pas'");
		if (!pp->p_finfull) BAG("deb_fin: no fin yet");
		for (i=0; i<pp->p_ury; i++) pp->p_durdeb[i] = pp->p_durfin[i];
		pp->p_finfull = 0;
		pp->p_debfull = 1;
		pp->p_recordwhat = RECORDFIN;
		pp->p_prevtime = pp->p_idcnt = 0;
		newletter(); wstring("fin"); send2(pr2cp, cptime, cptime+50);
		printf("recordfin....\n");
	}
	else if (!strcmp(s, "newrhythm")) 
		pp->p_recordwhat= pp->p_debfull= pp->p_finfull = pp->p_durcnt= 
			0;
	else if (!strcmp(s,"print"))
	{
		int x, c = 20;
		printf("seq %d, %d notes; run %d, sync %d\n", pp->p_seq, 
			p_kmax, pp->p_run, pp->p_sync);
		if (erint(&x)) x = 0;
		for (;c--; x++) printf("%d\td=%d\tl=%d\tc=%d\n",
			x, p_duree[x], p_longueur[x], p_coeff[x]);
	}
	else if (!strcmp(s,"chargez") || !strcmp(s,"nchargez"))
	{
		pp->p_durcnt= 0;
		printf("%s %s\n", s, rstring());
	}
	else if (!strcmp(s,"ecoute"))
	{
		/* on lance l'enveloppe et l'oscillateur d'ecriture */
		int cut = (1<<26);
		if (pp->p_which)
		{
        		R4_cut_fre = cut;
			R4_inc_wr = ONINCREMENT;
			R4_fin_wr = ONAMP;
			R4_pha_wr = R4_pha_wr = DEBUT;
			Led(1,1);
		}
		else
		{
        		R3_cut_fre = cut;
			R3_inc_wr = ONINCREMENT;
			R3_fin_wr = ONAMP;
			R3_pha_wr = R3_pha_wr = DEBUT;
			Led(0,1);
		}
		printf ("taratata...boum!boum!\n");
	}
	else if (!strcmp(s,"ignore"))	/* fermer l'enveloppe d'ecriture */
	{
		if (pp->p_which)
		{
			R4_inc_wr = OFFINCREMENT;
			R4_fin_wr = 0;
			Led(1,0);
		}
		else
		{
			R3_inc_wr = OFFINCREMENT;
			R3_fin_wr = 0;
			Led(0,0);
		}
		printf("FIN D'ENREGISTREMENT\n");
	}
	else if (!strcmp(s,"go"))
	{
		pp->p_count = 0;
		pp->p_run = 1;
		if (!pp->p_sync)
		{
			newletter(); wstring("phrase"); send2(cpno, cptime,
				cptime+T4);
			pp->p_sync = 1;
		}
		/* printf("...la ci darem la mano......\n"); */
	}
	else if (!strcmp(s,"continue"))
	{
		pp->p_run = 1;
		if (!pp->p_sync)
		{
			newletter(); wstring("phrase"); send2(cpno, cptime,
				cptime+T4);
			pp->p_sync = 1;
		}
		/* printf("...la ci darem la mano......\n"); */
	}
	else if (!strcmp(s,"chute")) pp->p_run = 0;
	else 
	{
		printf("sin: bad letter:\n");
		dumpletter();
	}
}

/*****************************************************************/
	
static int which = 0;		/* which instance this is */

 char *
sistart(argc, argv)
 char **argv;
{
	register struct pinst *pp;
	if (!which)
	{
		printf("\n");
		printf("\t*** putain     ***\n");
		printf("\t*** de conasse ***\n"); 
		printf("\t*** de merde   ***\n"); 
		printf("\t*** de chiason ***\n");
		printf("\n");
		/* zz_rate = 32000;
		realsetrate(32000); */
	}
	else if (which >= 2) hate("sin: no more than 2 allowed");
	else pp = &intinst[which];
	which++;
	pp->p_which = 0;
	pr2cp = cpston("print2");


	if (!p_dlist)
	{
		printf("alloc interpol memory ...\n");
		if (!(p_dlist = (short *)(malloc(NOTE*sizeof(short)))) ||
			!(p_llist = (short *)(malloc(NOTE*sizeof(short)))) ||
			!(p_alist = (short *)(malloc(NOTE*sizeof(int)))) ||
			!(p_clist = (int *)(malloc(NOTE*sizeof(int)))))
				hate("can't allocate memory");
		printf("... done\n");
		sinload("Interpol/inter1a.out", 0, 0, 0);	/* 0 */
		sinload("Interpol/inter1b.out", 1, 0, 0);	/* 1 */
		sinload("Interpol/inter1c.out", 0, 0, 0);	/* 2 */
		sinload("Interpol/inter1d.out", 0, 0, 0);	/* 3 */
		sinload("Interpol/inter2a.out", 0, 0, 0);	/* 4 */
		sinload("Interpol/inter2b.out", 0, 0, 0);	/* 5 */
		sinload("Interpol/inter2d.out", 1, 0, 0);	/* 6 */
		sinload("Interpol/ost1.out",	1, 1, 0);	/* 7 */
		sinload("Interpol/ost2.out",	1, 1, 0);	/* 8 */
		sinload("Interpol/ost3.out",	1, 1, 0);	/* 9 */
		sinload("Interpol/ost4.out",	1, 1, 0);	/* 10 */
		sinload("Interpol/ost4b.out",	1, 1, 0);	/* 11 */
		sinload("Interpol/inter2c.out", 0, 0, 0);	/* 12 */
		sinload("Interpol/ost5.out",	1, 2, 0);	/* 13 */
		sinload("Interpol/ost6.out",	1, 2, 0);	/* 14 */
		sinload("Interpol/ost7.out",	1, 2, 0);	/* 15 */
		sinload("Interpol/ost8.out",	1, 2, 0);	/* 16 */
		sinload("Interpol/inter3a.out", 0, 0, 1);	/* 17 */
		sinload("Interpol/inter3b.out", 1, 0, 1);	/* 18 */
	}
	pp->p_recordwhat = pp->p_debfull = pp->p_finfull = pp->p_durcnt = 
		pp->p_sync = 0;
	pp->p_recordwhat= pp->p_debfull= pp->p_finfull= pp->p_durcnt= 0;
	boppo(pp, 0);
	return((char *)pp);
}

boppo(pp, x)
 register struct pinst *pp;
{
	if (x < 0 || x >= nseq)
		printf("sequence number out of range\n");
	else
	{
		int off = x * NOTE, onset = onsets[x];
		p_kmax = onsets[x+1] - onsets[x];
		p_coeff = &p_clist[onset];
		p_amp = &p_alist[onset];
		p_duree = &p_dlist[onset];
		p_longueur = &p_llist[onset];
		pp->p_seq = x;
		pp->p_which = plaques[x];
		pp->p_recordwhat= pp->p_debfull= pp->p_finfull= pp->p_durcnt= 0;
	}
}

sistop(x)
 char *x;
{
}

/* this routine does the dirty work for calculating durations from realtime
inputs. To clear the durations set durcnt=0; then call addinter as desired */

#define LONGUEUR_MAX 2000

addinter(pp, duree_debut, duree_fin, ury, pas)
 int *duree_debut, *duree_fin;
 register struct pinst *pp;
{
	int i,ii,h,j,l,m,longue;
	float indices[MAXURY];
	static int *time = (int *)0;
	if (!time && !(time = (int *)malloc(1025 * sizeof(int))))
	{
		printf("addrhythm: out of space!\n");
		return;
	}
	time[0] = 0;

	pas = pas+1;	/* what!? -msp */
	/*---------definition de l'indice pour le calcul des retards-----*/
	for(i=0;i<ury;i++)
		indices[i] = (duree_fin[i] - duree_debut[i]) / (float)pas;
	/*
	printf("deb= ");
	for(i=0;i<ury;i++) printf("%d ", duree_debut[i]);
	printf("\nfin= ");
	for(i=0;i<ury;i++) printf("%d ", duree_fin[i]);
	printf("\n");
	*/

	/*----------calcul des indices pour les retards----------------*/
	for(i=0;i<pas+1;i++)
	{
		for(ii=0;ii<ury;ii++)
		{
			p_duree[pp->p_durcnt] = 
				duree_debut[ii] + i * indices[ii];
			if (pp->p_durcnt >=  p_kmax)
			{
				printf("too many durations!\n");
				return;
			}
				/* position de la note suivante */
				time[pp->p_durcnt+1] = time[pp->p_durcnt] + 
					p_duree[pp->p_durcnt];
				/* par defaut longueur = 2 s divise par coeff */
			p_longueur[pp->p_durcnt] = 0x10000 * 
				(((float)LONGUEUR_MAX) /
					p_coeff[pp->p_durcnt]);
				/* remove any overlap in same osc */
			if(pp->p_durcnt>=NB_OSC_LECT) 
			{

				int x=p_longueur[pp->p_durcnt-NB_OSC_LECT];
				longue= time[pp->p_durcnt] - 
					time[pp->p_durcnt-NB_OSC_LECT];
				p_longueur[pp->p_durcnt-NB_OSC_LECT] = 
				longue < x ? longue : x;
			}
			pp->p_durcnt++;
		}
     	}
	printf("\n%d durations\n", pp->p_durcnt);
}

sinload(name, useamp, plaque, half)
 char *name;
{
	int onset, bsize, i, fd, shit;
	int buf[1000];
	printf("fuck %s", name);
	fflush(stdout);
	if (nseq >= SEQ)
	{
		fprintf(stderr,"too many sequences\n");
		return;
	}
	onset = onsets[nseq];
	if ((fd = open(name,O_RDONLY | O_ALOCHST)) < 0)
	{
		fprintf(stderr,"can't open file\n");
		return;
	}
	if ((read(fd, &p_kmax,sizeof(int))) != sizeof(int))
	{
		printf("kmax: ");
		goto dammit;
	}
	if ( p_kmax > NOTE - onset)
	{
		printf("notelist too large\n");
		goto dammit;
	}
	if (p_kmax > 1000) p_kmax = 1000;
	if ((read(fd,&shit,sizeof(int))) != sizeof(int))
	{
		printf("shit: ");
		goto dammit;
	}
	bsize = p_kmax * sizeof(int);
	if ((read(fd,(char *)buf,  bsize))  !=  bsize)
	{
		printf("duree: ");
		goto dammit;
	}
	for (i = 0; i < p_kmax; i++) p_dlist[onset+i] = buf[i]&32767;
	if ((read(fd,(char *)buf,  bsize))  !=  bsize)
	{
		printf("longueur: ");
		goto dammit;
	}
	for (i = 0; i < p_kmax; i++) p_llist[onset+i] = buf[i]&32767;
	if ((read(fd,(char *)(p_clist+onset), bsize)) != bsize) 
	{
		printf("coeff: ");
		goto dammit;
	}
	if (useamp )
	{
		if ((read(fd,(char *)buf, bsize)) != bsize) 
		{
			printf("amp: ");
			goto dammit;
		}
		for (i = 0; i < p_kmax; i++) p_alist[onset+i] = buf[i]>>16;
	}
	else
	{
		int i = p_kmax;
		short *ap = p_alist+onset;
		for(; i-- ;ap++) *ap = 0x7fff;
	}
	if (half)
	{
		int i = p_kmax;
		short *ap = p_alist+onset;
		for(; i-- ;ap++) *ap >>= 1;
	}
	printf("(%d notes)\n",  p_kmax);
	plaques[nseq] = plaque;
	onsets[++nseq] = onset + p_kmax;
	close(fd);
	return;
dammit:	printf("read error\n");
	p_kmax = 0;
	close(fd);
	return;
}


