/* trigger.c msp 4/86.  Wait for an incoming latter which matches a given
/* pattern and on receipt send out other user-definable letters. */

#include <stdio.h>
#include "../sap/cplib.h"
extern long cptime;
#define NCHAR 200

struct pinst
{
	int p_arm;		/* whether armed */
	int p_repeat;		/* whether to rearm after a trigger comes in */
	char p_pattern[NCHAR];	/* thing to wait for */
	char p_send[NCHAR];	/* what to send when you get it */
	int p_debug;
};

char *trusage = 
   "usage: trigger [-{wn}] [pattern] [; letter] [; letter] ... ";

 char *
trstart(ac,av)
 char **av;
{
	register int i=0, debug = 0;
	struct pinst *pp= (struct pinst *)shmalloc(sizeof(struct pinst));
	register char *cp = pp->p_pattern, *endp = cp + NCHAR - 2;
	pp->p_arm = pp->p_repeat = 1;
	pp->p_debug = 0;
	ac--; av++;
	while (ac && **av == '-')
	{
		if (!strcmp (av[0], "-d")) pp->p_debug = 1;
		else if (!strcmp (av[0], "-w")) pp->p_arm = 0;
		else if (!strcmp (av[0], "-n")) pp->p_repeat = 0;
		else hate(trusage);
		ac--;av++;
	}
	while (*av && **av != ';')
	{
		char *argp = *av;
		while (*argp && cp < endp) *(cp++) = *(argp++);
		*(cp++) = '\0';
		av++;
	}
	if (*av && **av == ';') av++;
	*cp = '\0';
	cp = pp->p_send; endp = cp + NCHAR - 2;
	while (*av)
	{
		char *argp = *av;
		while (*argp && cp < endp) *(cp++) = *(argp++);
		*(cp++) = '\0';
		av++;
	}
	*cp = '\0';
	return ((char *)pp);
}

trread(cpp)
 register char *cpp;
{
	register struct pinst *pp = (struct pinst *)cpp;
	register char *s, *cp;
	if (pp->p_debug) printf("1 "); fflush(stdout);
	s = rstring();
	cp = pp->p_pattern;
	if (!strcmp(s,"newtrigger"))
	{
		register char *cp = pp->p_pattern, *endp = cp + NCHAR - 2;
		while (type() != L_NOMORE)
		{
			char *argp = rstring();
			while (*argp && cp < endp) *(cp++) = *(argp++);
			*(cp++) = '\0';
		}
		*cp = '\0';
		pp->p_arm = 1;
	}
	else if (!strcmp(s,"start")) pp->p_arm = 1;
	else if (!strcmp(s,"stop")) pp->p_arm = 0;
	else if (!strcmp(s,"repeat")) pp->p_repeat = 1;
	else if (!strcmp(s,"norepeat")) pp->p_repeat = 0;
	else if (!strcmp(s,"set"))
	{
		register char *cp = pp->p_send, *endp = cp + NCHAR - 2;
		while (type() != L_NOMORE)
		{
			char *argp = rstring();
			while (*argp && cp < endp) *(cp++) = *(argp++);
			*(cp++) = '\0';
		}
		*cp = '\0';
	}
	if (!pp->p_arm) return;
	if (pp->p_debug) printf("2 "); fflush(stdout);
	lrewind();
	for (;; cp++)
	{
		if (! *cp) break;
		if (type() == L_NOMORE) return;
		if (pp->p_debug) printf("3 "); fflush(stdout);
		for (s = rstring(); ; cp++, s++)
		{
			if (pp->p_debug) printf("%s (%s)\n", s, cp);
			if (*cp != *s) return;
			if (*cp == '\0') break;
		}
		if (*s != '\0') return;
	}

	cp = pp->p_send;
	while (*cp)
	{
		int whatcp, n = 0;
		if (*cp == ';') continue;
		if ((whatcp = ecpston(cp)) < 0)
		{
			printf("%s: no such CP\n", cp);
			while (*cp && *cp != ';') while (*(cp++));
		}
		else
		{
			while (*(cp++));	/* skip cp-to field */
			while (*cp && *cp != ';')
			{
				newletter(); n=0;
				while (*cp && *cp != ';' && *cp != ',')
				{
					if (*cp == '\\') cp++;
					wstring(cp);
					n++; 
					while (*(cp++));
				}
				if (n >= 0) send2(whatcp, cptime, cptime+50);
				if (*cp && *cp == ',') while (*(cp++));
			}
		}
		if (*cp) while (*(cp++));
	}
	pp->p_arm = pp->p_repeat;
}

trstop(s)
 register char *s;
{
	free(s);
}
